<script>

  import { getContext, onMount, onDestroy  } from 'svelte';
  import MenuItem                            from './MenuItem.svelte';

  export let menu     = null;
  export let name     = 'menu-item';
  export let type     = 'input';
  export let label    = 'Menu item';
  export let value    = '';
  export let index    = -1;
  export let depth    = 0;
  export let path     = [];
  export let classes  = [];

  const mainContext = getContext('main');

  path = path.slice(0);

  path.push(index);

  export const reset = function(e) {

    const idx = classes.indexOf('active');

    if(idx !== -1)
      classes.splice(idx, 1);

    classes = classes.slice(0);
  }

  export const onItemChange = function(e) {
    e.preventDefault();
    value = e.target.value;
    window.parent.postMessage(JSON.stringify({action: 'menu_change', data: {name, type, label, value, index, depth, path}}), '*');
  }
  
  export const onLabelClick = function(e) {
    e.preventDefault();
    mainContext.reset();
  }

  onMount(() => {
    mainContext.registerReset(reset);
  });

  onDestroy(() => {
    mainContext.unregisterReset(reset);
  });

</script>

<style>
  
  .menu-item {
    text-align: center;
    display: flex;
    flex-direction: column;
    height: 35px;
    line-height: 35px;
    width: 0;
    user-select: none;
  }
  
  .menu-item:hover {
    cursor: pointer;
  }
  
  .menu-item > .label {
    color: #fff;
    text-align: center;
    background-color: rgba(0, 0, 0, 0.75);
    height: 25px;
    padding: 0 5px 10px 5px;
    border-left: 1px solid rgba(143, 75, 75, 0.75);
    display: flex;
    flex-direction: row;
    justify-content: flex-start;
    white-space: nowrap;
  }

  .menu-item:nth-child(even) > .label {
    background-color: rgba(0, 0, 0, 0.85);
  }

  .menu-item.active > .label {
    color: rgb(170, 60, 60);
  }

  .label-children {
    display: none;
    flex-direction: column;
  }

  .label-value {
    color: rgb(170, 60, 60);
  }
  
	.label {
    display: flex;
    flex-direction: column;
		color: #000;
  }

  .label > input[type="text"] {
    width: calc(100% - 10px);
    height: calc(100% - 10px);
    text-align: center;
    font-size: 1em;
    padding: 5px;
    color: rgb(170, 60, 60);;
  }

  .label > input[type="text"]:focus {
    outline: none;
  }

</style>

<div class={`menu-item menu-item-input ${classes.join(' ')}`}>

  <div class="label" on:click={onLabelClick}>
    <input type="text" value={value} placeholder={label} on:keyup={onItemChange} />
  </div>
  
</div>
